/// <reference types="node" />
import { RPCResponse } from './net';
import { Middleware } from './util';
export declare type Subscriber = (event: any) => void;
export declare type Subscribers = Map<SubscriptionToken, Subscriber>;
declare type SubscriptionToken = symbol;
export interface Provider {
    middleware: Middleware;
    send<R = any, E = string>(method: string, ...params: any[]): Promise<RPCResponse<R, E>>;
    subscribe?(event: string, subscriber: Subscriber): symbol;
    unsubscribe?(token: symbol): void;
}
export declare abstract class Signer {
    abstract sign(payload: Signable): Promise<Signable>;
}
export interface Signable {
    bytes: Buffer;
}
/**
 * ZilliqaModule
 *
 * This interface must be implemented by all top-level modules.
 */
export interface ZilliqaModule {
    provider: Provider;
    signer: Signer;
}
export {};
//# sourceMappingURL=types.d.ts.map